<!--
 Copyright © VNG Realisatie 2024
 Licensed under the EUPL
-->

{{ define "content" }}
    <script>
        document.body.addEventListener("htmx:beforeSwap", function (evt) {
            if (
                evt.detail.xhr.status === 400 ||
                evt.detail.xhr.status === 500
            ) {
                evt.detail.shouldSwap = true;
                evt.detail.isError = false;
            }
        });
    </script>

    <p>
        <a href="/peers" class="button--link"
            >{{ svg "icon-chevron-left" "icon--inline" }} {{ i18n "Back" }}</a
        >
    </p>

    <div class="add-peer-page">
        {{ if ne (len .SuccessMessage) 0 }}
            <div class="alert--success">
                <p class="alert__title">{{ i18n "Success" }}</p>
                <p class="alert__content">{{ .SuccessMessage }}</p>
            </div>
        {{ end }}

        {{ if ne (len .ErrorMessages) 0 }}
            {{ block "errors" . }}
            {{ end }}
        {{ end }}


        <form
            hx-boost="true"
            action="/peers/add"
            method="post"
            autocomplete="off"
            class="add-peer-page__form"
            hx-disabled-elt="button[type=submit]"
        >
            <input
                type="hidden"
                name="csrfToken"
                value="{{ .BaseAuthenticatedPage.CsrfToken }}"
            />

            <fieldset class="add-peer-page__form-actions">
                <button type="submit" class="button--primary">
                    {{ i18n "Add Peer" }}
                </button>
            </fieldset>

            <fieldset>
                <legend>{{ i18n "Peer details" }}</legend>
                <label>
                    <span>{{ i18n "Name" }}</span>
                    <input
                        class="input--large"
                        type="text"
                        name="name"
                        value="{{ .Form.Name }}"
                        required
                        oninvalid="nameOnInvalidHandler(this)"
                        oninput="this.setCustomValidity('')"
                    />
                </label>

                <label>
                    <span>{{ i18n "Peer ID" }}</span>
                    <input
                        class="input--large"
                        type="text"
                        name="id"
                        value="{{ .Form.ID }}"
                        required
                        oninvalid="idOnInvalidHandler(this)"
                        oninput="this.setCustomValidity('')"
                    />
                </label>

                <label>
                    <span>{{ i18n "Manager Address" }}</span>
                    <input
                        class="input--large"
                        type="text"
                        name="managerAddress"
                        value="{{ .Form.ManagerAddress }}"
                        required
                        pattern="^https:\/\/\S+:8443$"
                        oninvalid="managerAddressOnInvalidHandler(this)"
                        oninput="this.setCustomValidity('')"
                    />
                </label>
            </fieldset>

<script>
    function nameOnInvalidHandler(el) {
        if (el.validity.valueMissing) {
            el.setCustomValidity('{{ i18n "Name of the Peer is required" }}')
        }
    }

    function idOnInvalidHandler(el) {
        if (el.validity.valueMissing) {
            el.setCustomValidity('{{ i18n "ID of the Peer is required" }}')
        }
    }

    function managerAddressOnInvalidHandler(el) {
        if (el.validity.valueMissing) {
            el.setCustomValidity('{{ i18n "Manager Address of the Peer is required" }}')
        } else if (el.validity.patternMismatch) {
            el.setCustomValidity('{{ i18n "Manager address must be a valid URL including the scheme https and the port 8443." }}')
        }
    }
</script>
        </form>
    </div>
{{ end }}
